using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace QuerySuppliersProducts
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmQuerySuppliersProducts : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox _lstResults;
		private System.Windows.Forms.Button _btnListSuppliers;
		private System.Windows.Forms.Button _btnListProducts;
		private System.Windows.Forms.TextBox _txtTable;
		private System.Windows.Forms.TextBox _txtWhereClause;
		private System.Windows.Forms.Button _btnAddRelation;
		private System.Windows.Forms.Button _btnAddRow;
		private System.Windows.Forms.Button _btnSave;
		private System.Windows.Forms.Button _btnQuery;
		#region Windows Form Designer generated code
		private System.Windows.Forms.MainMenu mainMenu1;

		public frmQuerySuppliersProducts()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this._lstResults = new System.Windows.Forms.ListBox();
			this._btnListSuppliers = new System.Windows.Forms.Button();
			this._btnListProducts = new System.Windows.Forms.Button();
			this._txtTable = new System.Windows.Forms.TextBox();
			this._txtWhereClause = new System.Windows.Forms.TextBox();
			this._btnAddRelation = new System.Windows.Forms.Button();
			this._btnAddRow = new System.Windows.Forms.Button();
			this._btnSave = new System.Windows.Forms.Button();
			this._btnQuery = new System.Windows.Forms.Button();
			// 
			// _lstResults
			// 
			this._lstResults.Location = new System.Drawing.Point(0, 8);
			this._lstResults.Size = new System.Drawing.Size(160, 254);
			// 
			// _btnListSuppliers
			// 
			this._btnListSuppliers.Location = new System.Drawing.Point(168, 8);
			this._btnListSuppliers.Text = "Suppliers";
			this._btnListSuppliers.Click += new System.EventHandler(this._btnListSuppliers_Click);
			// 
			// _btnListProducts
			// 
			this._btnListProducts.Location = new System.Drawing.Point(168, 32);
			this._btnListProducts.Text = "Products";
			this._btnListProducts.Click += new System.EventHandler(this._btnListProducts_Click);
			// 
			// _txtTable
			// 
			this._txtTable.Location = new System.Drawing.Point(168, 56);
			this._txtTable.Size = new System.Drawing.Size(72, 22);
			this._txtTable.Text = "Products";
			// 
			// _txtWhereClause
			// 
			this._txtWhereClause.Location = new System.Drawing.Point(168, 80);
			this._txtWhereClause.Size = new System.Drawing.Size(72, 22);
			this._txtWhereClause.Text = "ProductID = 77";
			// 
			// _btnAddRelation
			// 
			this._btnAddRelation.Location = new System.Drawing.Point(168, 128);
			this._btnAddRelation.Text = "Relation";
			this._btnAddRelation.Click += new System.EventHandler(this._btnAddRelation_Click);
			// 
			// _btnAddRow
			// 
			this._btnAddRow.Location = new System.Drawing.Point(168, 152);
			this._btnAddRow.Text = "Add Row";
			this._btnAddRow.Click += new System.EventHandler(this._btnAddRow_Click);
			// 
			// _btnSave
			// 
			this._btnSave.Location = new System.Drawing.Point(168, 176);
			this._btnSave.Text = "Save";
			this._btnSave.Click += new System.EventHandler(this._btnSave_Click);
			// 
			// _btnQuery
			// 
			this._btnQuery.Location = new System.Drawing.Point(168, 104);
			this._btnQuery.Text = "Query";
			this._btnQuery.Click += new System.EventHandler(this._btnQuery_Click);
			// 
			// frmQuerySuppliersProducts
			// 
			this.Controls.Add(this._btnQuery);
			this.Controls.Add(this._btnSave);
			this.Controls.Add(this._btnAddRow);
			this.Controls.Add(this._btnAddRelation);
			this.Controls.Add(this._txtWhereClause);
			this.Controls.Add(this._txtTable);
			this.Controls.Add(this._btnListProducts);
			this.Controls.Add(this._btnListSuppliers);
			this.Controls.Add(this._lstResults);
			this.Menu = this.mainMenu1;
			this.MinimizeBox = false;
			this.Text = "QuerySuppliersProducts";

		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		static void Main() 
		{
			Application.Run(new frmQuerySuppliersProducts());
		}
		#endregion


		private System.Data.DataSet _dataSet = null;
		private SqlDataAdapter _adapter = null;

		//connection string to connect with the Northwind DB
		private const string connectionStr  = 
			"DATABASE=Northwind;SERVER=JoshHolmesT30;UID=sa;PWD=123;";
		// Suppliers table and select statement
		private const string SuppliersTable  = "Suppliers";
		private const string SuppliersSelect  = "Select * From Suppliers";

		// Products table and select statement
		private const string ProductsTable  = "Products";
		private const string ProductsSelect  = "Select * From Products";

		// dataset name
		private const string DataSetTable  = "Table";

		// relation between the 2 tables
		private const string SupplierProductsRelation  = "SupplierProducts";

		// Products table columns
		private const string ProductNameCol  = "ProductName";
		private const string SupplierIDCol  = "SupplierID";
		private const string CategoryIDCol  = "CategoryID";
		private const string QuantityPerUnitCol  = "QuantityPerUnit";
		private const string UnitPriceCol  = "UnitPrice";
		private const string UnitsInStockCol  = "UnitsInStock";
		private const string UnitsOnOrderCol  = "UnitsOnOrder";
		private const string ReorderLevelCol  = "ReorderLevel";
		private const string DiscontinuedCol  = "Discontinued";


		private void _btnListSuppliers_Click(object sender, System.EventArgs e)
		{
			CreateDataTable(SuppliersTable, SuppliersSelect);
			AddRowsToListBox(_dataSet.Tables[SuppliersTable].Select());
		}
		private void _btnListProducts_Click(object sender, System.EventArgs e)
		{
			CreateDataTable(ProductsTable, ProductsSelect);
			AddRowsToListBox(_dataSet.Tables[ProductsTable].Select());
		}

		private void AddRowsToListBox(System.Data.DataRow[] rows)
		{
			_lstResults.Items.Clear();
			for(int i = 0; i < rows.Length; i++)
			{
				string results = "";
				for (int j = 0; j < rows[i].ItemArray.Length; j++)
				{
					results += " " + rows[i][j, 
						System.Data.DataRowVersion.Current].ToString();
				}
				_lstResults.Items.Add(results);
			}
		}
		private void CreateDataTable(string tableName, string tableSelect)
		{
			try
			{
				if (_dataSet == null)
				{
					_dataSet = new DataSet();
				}
				else if(_dataSet.Tables.Contains(tableName))
				{
					return;
				}

				SqlConnection sqlconn = new SqlConnection(connectionStr);
				sqlconn.Open();
				_adapter = new SqlDataAdapter();
				_adapter.TableMappings.Add(DataSetTable, tableName);
				_adapter.SelectCommand = new SqlCommand(tableSelect, sqlconn);
				_adapter.Fill(_dataSet);
				sqlconn.Close();
			}
			catch (Exception ex)
			{

				MessageBox.Show("Exception while creating " + tableName
					+ " table: " + ex.ToString());
			}
		}

		private void _btnQuery_Click(object sender, System.EventArgs e)
		{
			try
			{
				if (_dataSet == null)
				{
					CreateDataTable(SuppliersTable, SuppliersSelect);
					CreateDataTable(ProductsTable, ProductsSelect);
				}

				System.Data.DataRow[] rows = _dataSet.Tables[_txtTable.Text].Select(_txtWhereClause.Text);

				AddRowsToListBox(rows);
			}
			catch (Exception ex)
			{
				MessageBox.Show("Exception while querying table: " +
					ex.ToString());
			}
		}

		private void _btnAddRelation_Click(object sender, System.EventArgs e)
		{
			try
			{
				if (_dataSet == null)
				{
					CreateDataTable(SuppliersTable, SuppliersSelect);
					CreateDataTable(ProductsTable, ProductsSelect);
				}

				System.Data.DataColumn parentCol = 
					_dataSet.Tables[SuppliersTable].Columns[SupplierIDCol];

				System.Data.DataColumn childCol =
					_dataSet.Tables[ProductsTable].Columns[SupplierIDCol];

				System.Data.DataRelation relation = 
					new System.Data.DataRelation(SupplierProductsRelation, 	parentCol, childCol);

				_dataSet.Relations.Add(relation);
			}
			catch(Exception ex)
			{
				MessageBox.Show("Exception while adding new relation: " 
					+ ex.ToString());
			}
		}

		private void _btnAddRow_Click(object sender, System.EventArgs e)
		{
			try
			{
				if (_dataSet == null)
				{
					CreateDataTable(SuppliersTable, SuppliersSelect);
					CreateDataTable(ProductsTable, ProductsSelect);
				}

				System.Data.DataTable productTable = 
					_dataSet.Tables[ProductsTable];
				System.Data.DataRow DataRow = 
					productTable.NewRow();
				
				DataRow.BeginEdit();
				// make up some data by stealing from other rows 
				// (up to 77 rows in this db by default)
				DataRow[ProductNameCol] = 
					_dataSet.Tables[ProductsTable].Rows[0][ProductNameCol];

				DataRow[SupplierIDCol] = 
					_dataSet.Tables[ProductsTable].Rows[1][SupplierIDCol];

				DataRow[CategoryIDCol] = 
					_dataSet.Tables[ProductsTable].Rows[2][CategoryIDCol];

				DataRow[QuantityPerUnitCol] = 
					_dataSet.Tables[ProductsTable].Rows[3][QuantityPerUnitCol];

				DataRow[UnitPriceCol] = 
					_dataSet.Tables[ProductsTable].Rows[4][UnitPriceCol];

				DataRow[UnitsInStockCol] = 
					_dataSet.Tables[ProductsTable].Rows[5][UnitsInStockCol];

				DataRow[UnitsOnOrderCol] = 
					_dataSet.Tables[ProductsTable].Rows[6][UnitsOnOrderCol];

				DataRow[ReorderLevelCol] = 
					_dataSet.Tables[ProductsTable].Rows[7][ReorderLevelCol];

				DataRow[DiscontinuedCol] = 
					_dataSet.Tables[ProductsTable].Rows[8][DiscontinuedCol];

				productTable.Rows.Add(DataRow);
			}
			catch (Exception ex)
			{
				MessageBox.Show("Exception while adding new row: " + ex.ToString());
			}
		}

		private void _btnSave_Click(object sender, System.EventArgs e)
		{
			try
			{
				new SqlCommandBuilder(_adapter);
				_adapter.Update(_dataSet);
			}
			catch (Exception ex)
			{
				MessageBox.Show("Exception while saving Product table: " +
					ex.ToString());
			}
		}

	}
}
