using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlServerCe;
using System.IO;

namespace SqlServerCEFun
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		private const string DATABASE_DIRECTORY = @"\Program Files\SqlServerCEFun\";
		private const string DATABASE_PATH = DATABASE_DIRECTORY + "Test.sdf";
		private const string CE_CONNECTION_STRING = "Data Source='" + DATABASE_PATH + "';";

		private System.Windows.Forms.Button _btnCreate;
		private System.Windows.Forms.ComboBox _cboTables;
		private System.Windows.Forms.Button _btnList;
		private System.Windows.Forms.DataGrid _dataMain;
		private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn1;
		private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn2;
		#region Windows Form Designer generated code
		private System.Windows.Forms.MainMenu mainMenu1;

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this._btnCreate = new System.Windows.Forms.Button();
			this._cboTables = new System.Windows.Forms.ComboBox();
			this._btnList = new System.Windows.Forms.Button();
			this._dataMain = new System.Windows.Forms.DataGrid();
			this.dataGridTextBoxColumn1 = new System.Windows.Forms.DataGridTextBoxColumn();
			this.dataGridTextBoxColumn2 = new System.Windows.Forms.DataGridTextBoxColumn();
			// 
			// _btnCreate
			// 
			this._btnCreate.Location = new System.Drawing.Point(8, 8);
			this._btnCreate.Text = "Create";
			this._btnCreate.Click += new System.EventHandler(this._btnCreate_Click);
			// 
			// _cboTables
			// 
			this._cboTables.Location = new System.Drawing.Point(8, 32);
			this._cboTables.Size = new System.Drawing.Size(224, 22);
			this._cboTables.SelectedIndexChanged += new System.EventHandler(this._cboTables_SelectedIndexChanged);
			// 
			// _btnList
			// 
			this._btnList.Location = new System.Drawing.Point(88, 8);
			this._btnList.Text = "List";
			this._btnList.Click += new System.EventHandler(this._btnList_Click);
			// 
			// _dataMain
			// 
			this._dataMain.Location = new System.Drawing.Point(8, 56);
			this._dataMain.Size = new System.Drawing.Size(224, 200);
			this._dataMain.Text = "dataGrid1";
			this._dataMain.Click += new System.EventHandler(this._dataMain_Click);
			// 
			// dataGridTextBoxColumn1
			// 
			this.dataGridTextBoxColumn1.HeaderText = "Name";
			this.dataGridTextBoxColumn1.MappingName = "name";
			this.dataGridTextBoxColumn1.NullText = "(null)";
			// 
			// dataGridTextBoxColumn2
			// 
			this.dataGridTextBoxColumn2.HeaderText = "Age";
			this.dataGridTextBoxColumn2.MappingName = "age";
			this.dataGridTextBoxColumn2.NullText = "(null)";
			// 
			// frmMain
			// 
			this.Controls.Add(this._dataMain);
			this.Controls.Add(this._btnList);
			this.Controls.Add(this._cboTables);
			this.Controls.Add(this._btnCreate);
			this.Menu = this.mainMenu1;
			this.MinimizeBox = false;
			this.Text = "SqlServerCEFun";

		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		static void Main() 
		{
			Application.Run(new frmMain());
		}
		#endregion

		private void CreateDatabase()
		{
			if (File.Exists(DATABASE_PATH))
			{
				File.Delete(DATABASE_PATH);
			}
			else if (!Directory.Exists(DATABASE_DIRECTORY))
			{
				Directory.CreateDirectory(DATABASE_DIRECTORY);
			}

			SqlCeEngine engine = new SqlCeEngine(CE_CONNECTION_STRING);
			engine.CreateDatabase(); // Requires that the folder exists
			engine.Dispose();
		}

		private void CreateTablesInDatabase()
		{
			SqlCeConnection conn = null;
			try
			{
				conn = new SqlCeConnection(CE_CONNECTION_STRING);
				conn.Open();

				SqlCeCommand cmd = conn.CreateCommand();
				cmd.CommandText = "CREATE TABLE Employee (id ntext, name ntext, age int)";
				cmd.ExecuteNonQuery();
				cmd.CommandText = "Insert into Employee (id, name, age) Values ('1', 'Joe Blow', 30)";
				cmd.ExecuteNonQuery();
				cmd.CommandText = "Insert into Employee (id, name, age) Values ('2', 'Jack Smith', 45)";
				cmd.ExecuteNonQuery();
				cmd.CommandText = "CREATE TABLE Region (id ntext, name ntext)";
				cmd.ExecuteNonQuery();
				cmd.CommandText = "Insert Into Region (id, name) Values ('1', 'North America')";
				cmd.ExecuteNonQuery();
				cmd.CommandText = "Insert Into Region (id, name) Values ('2', 'South America')";
				cmd.ExecuteNonQuery();
			}
			catch (SqlCeException ex)
			{
				string msg = ex.ToString() + "\n";
				foreach (SqlCeError err in ex.Errors)
				{
					msg += err.Message + "\n";
				}
				MessageBox.Show(msg);
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
			finally
			{
				if ((conn != null) && (conn.State == ConnectionState.Open))
				{
					conn.Close();
				}
			}
		}

		private void _btnCreate_Click(object sender, System.EventArgs e)
		{
			CreateDatabase();
			CreateTablesInDatabase();
		}

		private void _btnList_Click(object sender, System.EventArgs e)
		{
			GetTablesFromDatabase();
		}	
		
		private void GetTablesFromDatabase()
		{
			string sql = "Select Table_Name from Information_Schema.Tables " + "where Table_Type = 'TABLE'";
			SqlCeConnection conn = null;

			try
			{
				conn = new SqlCeConnection(CE_CONNECTION_STRING);
				conn.Open();

				SqlCeCommand cmd = conn.CreateCommand();
				cmd.CommandText = sql;
				SqlCeDataReader reader = cmd.ExecuteReader();
				_cboTables.Items.Clear();
				while (reader.Read())
				{
					_cboTables.Items.Add(reader["Table_Name"]);
				}
			}
			catch (SqlCeException ex)
			{
				string msg = ex.ToString() + "\n";
				foreach (SqlCeError err in ex.Errors)
				{
					msg += err.Message + "\n";
				}
				MessageBox.Show(msg);
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
			finally
			{
				if ((conn != null) && (conn.State == ConnectionState.Open))
				{
					conn.Close();
				}
			}
		}

		private void _cboTables_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			ShowTable(_cboTables.Text);
		}																																						
		private void ShowTable(string TableName)
		{
			string sql = "Select * from " + TableName;
			SqlCeConnection conn = null;

			try
			{
				conn = new SqlCeConnection(CE_CONNECTION_STRING);
				conn.Open();

				SqlCeCommand cmd = conn.CreateCommand();
				cmd.CommandText = sql;

				DataSet dataSet = new DataSet();
				SqlCeDataAdapter adapter = new SqlCeDataAdapter(cmd);
				adapter.Fill(dataSet);

				_dataMain.DataSource = dataSet.Tables[0];
			}
			catch (SqlCeException ex)
			{
				string msg = ex.ToString() + "\n";
				foreach (SqlCeError err in ex.Errors)
				{
					msg += err.Message + "\n";
				}
				MessageBox.Show(msg);
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
			finally
			{
				if ((conn != null) && (conn.State == ConnectionState.Open))
				{
					conn.Close();
				}
			}				  
		}

		private void _dataMain_Click(object sender, System.EventArgs e)
		{
		
		}
	}
}