using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlServerCe;
using System.IO;

namespace SqlServerCERDA
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmSqlServerCERDA : System.Windows.Forms.Form
	{
		private const string DATABASE_DIRECTORY = 
			@"\Program Files\SqlServerCERDA\";
		private const string DATABASE_PATH = DATABASE_DIRECTORY + "Test.sdf";

		private const string CE_CONNECTION_STRING = "Data Source='" + DATABASE_PATH + "';";
		private const string SQL_CONNECTION_STRING = "Provider=sqloledb; " + 
			"Data Source=192.168.2.143;" + 
			"Initial Catalog=Northwind;" + 
			"User Id=sa;" + 
			"pwd=123;";
		private const string URL = "http://192.168.2.143/sqlce/sscesa20.dll";
		private System.Windows.Forms.Button _btnCreate;
		private System.Windows.Forms.Button _btnPull;
		private System.Windows.Forms.ComboBox _cboTables;
		private System.Windows.Forms.DataGrid _dataMain;
		private System.Windows.Forms.Button _btnPush;

		#region Windows Form Designer generated code
		private System.Windows.Forms.MainMenu mainMenu1;

		public frmSqlServerCERDA()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this._btnPull = new System.Windows.Forms.Button();
			this._btnCreate = new System.Windows.Forms.Button();
			this._cboTables = new System.Windows.Forms.ComboBox();
			this._dataMain = new System.Windows.Forms.DataGrid();
			this._btnPush = new System.Windows.Forms.Button();
			// 
			// _btnPull
			// 
			this._btnPull.Location = new System.Drawing.Point(88, 8);
			this._btnPull.Text = "Pull";
			this._btnPull.Click += new System.EventHandler(this._btnPull_Click);
			// 
			// _btnCreate
			// 
			this._btnCreate.Location = new System.Drawing.Point(8, 8);
			this._btnCreate.Text = "Create";
			this._btnCreate.Click += new System.EventHandler(this._btnCreate_Click);
			// 
			// _cboTables
			// 
			this._cboTables.Location = new System.Drawing.Point(8, 32);
			this._cboTables.Size = new System.Drawing.Size(224, 22);
			// 
			// _dataMain
			// 
			this._dataMain.Location = new System.Drawing.Point(8, 56);
			this._dataMain.Size = new System.Drawing.Size(224, 208);
			this._dataMain.Text = "dataGrid1";
			// 
			// _btnPush
			// 
			this._btnPush.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular);
			this._btnPush.Location = new System.Drawing.Point(168, 8);
			this._btnPush.Text = "Push";
			this._btnPush.Click += new System.EventHandler(this._btnPush_Click);
			// 
			// frmSqlServerCERDA
			// 
			this.Controls.Add(this._btnPush);
			this.Controls.Add(this._dataMain);
			this.Controls.Add(this._cboTables);
			this.Controls.Add(this._btnPull);
			this.Controls.Add(this._btnCreate);
			this.Menu = this.mainMenu1;
			this.MinimizeBox = false;
			this.Text = "SqlServerCERDA";

		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		static void Main() 
		{
			Application.Run(new frmSqlServerCERDA());
		}
		#endregion

		private void CreateDatabase()
		{
			if (File.Exists(DATABASE_PATH))
			{
				File.Delete(DATABASE_PATH);
			}
			else if (!Directory.Exists(DATABASE_DIRECTORY))
			{
				Directory.CreateDirectory(DATABASE_DIRECTORY);
			}

			SqlCeEngine engine = new SqlCeEngine(CE_CONNECTION_STRING);
			engine.CreateDatabase(); // Requires that the folder exists
			engine.Dispose();
		}

		private void PullFromSqlServer()
		{
			SqlCeRemoteDataAccess rda = null;
			try
			{
				rda = new SqlCeRemoteDataAccess();

				rda.InternetUrl = URL;
				rda.LocalConnectionString = CE_CONNECTION_STRING;
				rda.Pull("Employees", "Select * from Employees", SQL_CONNECTION_STRING, RdaTrackOption.TrackingOn);
			}
			catch (SqlCeException ex)
			{
				string msg = ex.ToString() + "/n";
				foreach (SqlCeError err in ex.Errors)
				{
					msg += err.Message + "/n";
				}
				MessageBox.Show(msg);
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void _btnCreate_Click(object sender, System.EventArgs e)
		{
			CreateDatabase();
		}

		private void _btnPull_Click(object sender, System.EventArgs e)
		{
			PullFromSqlServer();
			GetTablesFromDatabase();
		}

		private void GetTablesFromDatabase()
		{
			string sql = "Select Table_Name from Information_Schema.Tables " + "where Table_Type = 'TABLE'";
			SqlCeConnection conn = null;

			try
			{
				conn = new SqlCeConnection(CE_CONNECTION_STRING);
				conn.Open();

				SqlCeCommand cmd = conn.CreateCommand();
				cmd.CommandText = sql;
				SqlCeDataReader reader = cmd.ExecuteReader();
				_cboTables.Items.Clear();
				while (reader.Read())
				{
					_cboTables.Items.Add(reader["Table_Name"]);
				}
			}
			catch (SqlCeException ex)
			{
				string msg = ex.ToString() + "/n";
				foreach (SqlCeError err in ex.Errors)
				{
					msg += err.Message + "/n";
				}
				MessageBox.Show(msg);
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
			finally
			{
				if ((conn != null) && (conn.State == ConnectionState.Open))
				{
					conn.Close();
				}
			}
		}

		private void _cboTables_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			ShowTable(_cboTables.Text);
		}	
												
		private void ShowTable(string TableName)
		{
			string sql = "Select * from " + TableName;
			SqlCeConnection conn = null;

			try
			{
				conn = new SqlCeConnection(CE_CONNECTION_STRING);
				conn.Open();

				SqlCeCommand cmd = conn.CreateCommand();
				cmd.CommandText = sql;

				DataSet dataSet = new DataSet();
				SqlCeDataAdapter adapter = new SqlCeDataAdapter(cmd);
				adapter.Fill(dataSet);

				_dataMain.DataSource = dataSet.Tables[0];
			}
			catch (SqlCeException ex)
			{
				string msg = ex.ToString() + "/n";
				foreach (SqlCeError err in ex.Errors)
				{
					msg += err.Message + "/n";
				}
				MessageBox.Show(msg);
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
			finally
			{
				if ((conn != null) && (conn.State == ConnectionState.Open))
				{
					conn.Close();
				}
			}				  
		}

		private void ChangeData()
		{
			DataTable dataTable = _dataMain.DataSource as DataTable;
			DataRow firstEmployee = dataTable.Rows[0];
			int reportsTo = Convert.ToInt32(firstEmployee["ReportsTo"]);
			reportsTo += 1;

			string sql = "UPDATE Employees SET " + 
				" ReportsTo = " + reportsTo.ToString() + 
				" Where EmployeeID = " + 
				firstEmployee["EmployeeID"].ToString();

			SqlCeConnection conn = null;

			try
			{
				conn = new SqlCeConnection(CE_CONNECTION_STRING);
				conn.Open();

				SqlCeCommand cmd = conn.CreateCommand();
				cmd.CommandText = sql;

				cmd.ExecuteNonQuery();
			}
			catch (SqlCeException ex)
			{
				string msg = ex.ToString() + "/n";
				foreach (SqlCeError err in ex.Errors)
				{
					msg += err.Message + "/n";
				}
				MessageBox.Show(msg);
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
			finally
			{
				if ((conn != null) && (conn.State == ConnectionState.Open))
				{
					conn.Close();
				}
			}
		}

		private void _btnPush_Click(object sender, System.EventArgs e)
		{
			ChangeData();
			ShowTable("Employees");
			PushToSQLServer();
		}

		private void PushToSQLServer()
		{
			SqlCeRemoteDataAccess rda = null;
			try
			{
				rda = new SqlCeRemoteDataAccess();

				rda.InternetUrl = URL;
				rda.LocalConnectionString = CE_CONNECTION_STRING;
				rda.Push("Employees", SQL_CONNECTION_STRING);
			}
			catch (SqlCeException ex)
			{
				string msg = ex.ToString() + "/n";
				foreach (SqlCeError err in ex.Errors)
				{
					msg += err.Message + "/n";
				}
				MessageBox.Show(msg);
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}
	}
}
